SystemOrganization addCategory: 'SqueakSource-Statistics-Model'!
SystemOrganization addCategory: 'SqueakSource-Statistics-View'!

!SSHome methodsFor: '*SqueakSource-Statistics-configuration' stamp: 'lr 2/19/2004 12:59'!
defaultLongSize
	^20! !

!SSHome methodsFor: '*SqueakSource-Statistics-configuration' stamp: 'pmm 10/26/2006 22:26'!
defaultShortSize
	^4! !

!SSHome methodsFor: '*SqueakSource-Statistics-accessing' stamp: 'al 7/26/2004 14:32'!
membersActive
	^self statistics membersActive! !

!SSHome methodsFor: '*SqueakSource-Statistics-accessing' stamp: 'al 7/26/2004 14:32'!
membersNew
	^self statistics membersNew! !

!SSHome methodsFor: '*SqueakSource-Statistics-accessing' stamp: 'al 7/26/2004 14:33'!
projectsActive
	^self statistics projectsActive! !

!SSHome methodsFor: '*SqueakSource-Statistics-accessing' stamp: 'al 7/26/2004 14:33'!
projectsDownloads
	^self statistics projectsDownloads! !

!SSHome methodsFor: '*SqueakSource-Statistics-accessing' stamp: 'al 7/26/2004 14:33'!
projectsNew
	^self statistics projectsNew! !

!SSHome methodsFor: '*SqueakSource-Statistics-accessing' stamp: 'al 7/26/2004 14:40'!
projectsRecent
	^self statistics projectsRecent! !

!SSHome methodsFor: '*SqueakSource-Statistics-rendering' stamp: 'topa 3/14/2011 09:34'!
renderLabel: aString list: aListSelector click: aClickSelector more: aMoreSelector on: html
	| fullCollection shortCollection |
	fullCollection := self perform: aListSelector.
	fullCollection := fullCollection first: (self defaultLongSize min: fullCollection size).
	fullCollection isEmpty ifFalse: [
		shortCollection := fullCollection first: (self defaultShortSize min: fullCollection size).
		html definitionTerm
			class: 'largeLabel';
			with: aString , ':'.
		html definitionData: [
			shortCollection
				do: [ :each | 
					html anchor
						callback: [ self perform: aClickSelector with: each ];
						with: each ]
				separatedBy: [ html text: ', ' ].
			shortCollection size < fullCollection size ifTrue: [ 
				html text: ', '.
				html anchor
					callback: [ self perform: aMoreSelector with: fullCollection with: aString ];
					with: '...' ] ] ]! !

!SSHome methodsFor: '*SqueakSource-Statistics-rendering' stamp: 'dkh 05/17/2011 16:47'!
renderStatisticsOn: html
	html heading level2; with: 'Statistics'.
	html heading level3; with: 'Members (' , self model membersCount greaseString , ')'.
	html definitionList: [ self
		renderLabel: 'Recently Joined' list: #membersNew click: #showMember: more: #showMoreMembers:titled: on: html;
		renderLabel: 'Most Active' list: #membersActive click: #showMember: more: #showMoreMembers:titled: on: html].
	html heading level3; with: 'Projects (' , self model projectsCount greaseString , ')' .
	html definitionList: [ self
		renderLabel: 'Recently Created' list: #projectsNew click: #showProject: more: #showMoreProjects:titled: on: html;
		renderLabel: 'Recently Used' list: #projectsRecent click: #showProject: more: #showMoreProjects:titled: on: html;
		renderLabel: 'Most Active' list: #projectsActive click: #showProject: more: #showMoreProjects:titled: on: html;
		renderLabel: 'Most Downloads' list: #projectsDownloads click: #showProject: more: #showMoreProjects:titled: on: html].! !

!SSHome methodsFor: '*SqueakSource-Statistics-actions' stamp: 'dkh 05/17/2011 16:47'!
showMember: aMember
	self call: aMember view! !

!SSHome methodsFor: '*SqueakSource-Statistics-actions' stamp: 'dkh 05/17/2011 16:47'!
showMoreMembers: aCollection titled: aString
	self call: ((SSListPrinter model: aCollection)
		title: aString;
		renderBlock: [ :html :value | 
			html anchor
				callback: [ self showMember: value ];
				with: value ];
		yourself)! !

!SSHome methodsFor: '*SqueakSource-Statistics-actions' stamp: 'dkh 05/17/2011 16:47'!
showMoreProjects: aCollection titled: aString
	self call: ((SSListPrinter model: aCollection)
		title: aString;
		renderBlock: [ :html :value | 
			html anchor
				callback: [ self showProject: value ];
				with: value ];
		yourself)! !

!SSHome methodsFor: '*SqueakSource-Statistics-actions' stamp: 'dkh 05/17/2011 16:48'!
showProject: aProject
	self call: aProject view! !

!SSHome methodsFor: '*SqueakSource-Statistics-accessing' stamp: 'al 7/26/2004 14:32'!
statistics
	^self model statistics! !

WAObject subclass: #SSStatistics
	instanceVariableNames: 'model cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Statistics-Model'!

SSStatistics class
	instanceVariableNames: 'registry'!

!SSStatistics class methodsFor: 'registration' stamp: 'topa 5/24/2011 15:47'!
for: aSSRepository

	^ self registry
		at: aSSRepository
		ifAbsentPut: [self model: aSSRepository]! !

!SSStatistics class methodsFor: 'instance creation' stamp: 'al 7/26/2004 14:38'!
model: aRepository
	^self basicNew
		model: aRepository;
		initialize;
		yourself! !

!SSStatistics class methodsFor: 'accessing' stamp: 'topa 5/24/2011 15:45'!
registry

	^ registry ifNil: [registry := GRPlatform current reducedConflictDictionary new]! !

!SSStatistics class methodsFor: 'accessing' stamp: 'dkh 05/24/2011 10:40'!
registry: anObject

	registry := anObject.! !

!SSStatistics class methodsFor: 'registration' stamp: 'topa 5/24/2011 15:49'!
unregister: aSSRepository

	^ self registry removeKey: aSSRepository! !

!SSStatistics methodsFor: 'calculation' stamp: 'pmm 10/26/2006 20:57'!
calculate
	self calculateMembersActive.
	Processor yield.
	self calculateMembersNew.
	Processor yield.
	self calculateProjectsActive.
	Processor yield.
	self calculateProjectsDownloads.
	Processor yield.
	self calculateProjectsNew.
	Processor yield.
	self calculateProjectsRecent! !

!SSStatistics methodsFor: 'calculation' stamp: 'pmm 6/30/2010 18:13'!
calculateMembersActive
	| histogram value |
	histogram := Dictionary new.
	self model visibleProjectsTo: SSMember anonymousMember do: [ :project |
		project versionsDo: [ :version |
			value := histogram at: version author ifAbsent: [ 0.0 ].
			histogram at: version author put: value + version activity ] ].
	cache at: #membersActive put: (self model members asSortedCollection: [ :x :y |
		(histogram at: x ifAbsent: [ 0.0 ]) >= (histogram at: y ifAbsent: [ 0.0 ]) ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'al 7/26/2004 14:21'!
calculateMembersNew
	cache at: #membersNew put: (self model members asSortedCollection: [ :x :y |
		x timestamp >= y timestamp ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'pmm 10/26/2006 20:53'!
calculateProjectsActive
	cache at: #projectsActive put: (self model projects asSortedCollection: [ :x :y |
		x cachedAbsoluteActivity >= y cachedAbsoluteActivity ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'pmm 10/26/2006 20:53'!
calculateProjectsDownloads
	cache at: #projectsDownloads put: (self model projects asSortedCollection: [ :x :y |
		x cachedDownloads >= y cachedDownloads ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'al 7/26/2004 14:23'!
calculateProjectsNew
	cache at: #projectsNew put: (self model projects asSortedCollection: [ :x :y |
		x timestamp >= y timestamp ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'pmm 6/30/2010 18:13'!
calculateProjectsRecent
	| associations |
	associations := SortedCollection sortBlock: [ :x :y |
		x value timestamp >= y value timestamp ].
	self model visibleProjectsTo: SSMember anonymousMember do: [ :project |
		project versionsDo: [ :version |
			associations add: project -> version ] ].
	cache at: #projectsRecent put: (associations collect: [ :each | 
		each key ])! !

!SSStatistics methodsFor: 'initialize-release' stamp: 'topa 5/24/2011 15:49'!
initialize
	super initialize.
	cache := GRPlatform current reducedConflictDictionary new.
	self calculate! !

!SSStatistics methodsFor: 'accessing' stamp: 'pmm 10/26/2006 20:55'!
membersActive
	^cache at: #membersActive! !

!SSStatistics methodsFor: 'accessing' stamp: 'pmm 10/26/2006 20:55'!
membersNew
	^cache at: #membersNew! !

!SSStatistics methodsFor: 'accessing' stamp: 'al 7/26/2004 14:16'!
model
	^model! !

!SSStatistics methodsFor: 'accessing' stamp: 'dkh 05/17/2011 16:49'!
model: aRepository
	model := aRepository! !

!SSStatistics methodsFor: 'accessing' stamp: 'pmm 10/26/2006 20:56'!
projectsActive
	^cache at: #projectsActive! !

!SSStatistics methodsFor: 'accessing' stamp: 'pmm 10/26/2006 20:56'!
projectsDownloads
	^cache at: #projectsDownloads! !

!SSStatistics methodsFor: 'accessing' stamp: 'pmm 10/26/2006 20:56'!
projectsNew
	^cache at: #projectsNew! !

!SSStatistics methodsFor: 'accessing' stamp: 'pmm 10/26/2006 20:56'!
projectsRecent
	^cache at: #projectsRecent! !

!SSRepository class methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 10/23/2006 16:27'!
reinititalizeInfos
	"self reinititalizeInfos"
	self current reinititalizeInfos! !

!SSRepository class methodsFor: '*SqueakSource-Statistics' stamp: 'topa 5/24/2011 15:42'!
statistics
	" the statistics provider "
	^ SSStatistics! !

!SSRepository class methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 10/16/2006 12:53'!
updateCache
	"self updateCache"
	self current updateCache! !

!SSRepository methodsFor: '*SqueakSource-Statistics' stamp: 'topa 10/22/2010 07:52'!
reinititalizeInfos
	self projectsDo: [ :each |
		each reinititalizeInfos.
		GRPlatform current seasideGarbageCollect]! !

!SSRepository methodsFor: '*SqueakSource-Statistics' stamp: 'topa 5/24/2011 15:41'!
statistics

	^ self class statistics for: self! !

!SSRepository methodsFor: '*SqueakSource-Statistics' stamp: 'topa 5/24/2011 15:54'!
unregisterStatistics

	<finalize>
	self class statistics unregister: self.! !

!SSRepository methodsFor: '*SqueakSource-Statistics' stamp: 'topa 11/2/2010 12:12'!
updateCache
	| maxActivity |
	maxActivity := 0.
	self projectsDo: [ :each |
		each 
			updateCachedDownloads;
			updateCachedNumberOfNormalVersions;
			updateCachedNumberOfReleases.
		maxActivity := maxActivity max:  each updateCachedAbsoluteActivity.
		Processor yield ].
	self projectsDo: [ : each |
		each updateCachedRelativeActivity: maxActivity.
		Processor yield ].

	self membersDo: [ :	each|
		each
			updateCachedCommitCount;
			updateCachedProjectCount.
		Processor yield ].! !

!SSVersion methodsFor: '*SqueakSource-Statistics-initialization' stamp: 'dkh 05/17/2011 16:50'!
reinititalizeInfoFor: aProject
	self initializeFromReader: (self reader: aProject)! !

!SSProject class methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 10/16/2006 11:34'!
absoluteActivityKey
	^#absoluteActivity! !

!SSProject class methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 10/16/2006 13:09'!
downloadsKey
	^#downloads! !

!SSProject class methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 11/15/2006 11:48'!
numberOfNormalVersionsKey
	^#numberOfNormalVersions! !

!SSProject class methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 11/15/2006 11:48'!
numberOfReleasesKey
	^#numberOfReleases! !

!SSProject class methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 10/16/2006 11:34'!
relativeActivityKey
	^#relativeActivity! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'topa 10/4/2010 10:53'!
cache
	
	^ self propertyAt: #cache
		ifAbsentPut: [IdentityDictionary new]! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 10/16/2006 11:38'!
cachedAbsoluteActivity
	^self cache
		at: self class absoluteActivityKey
		ifAbsentPut: [  self activity ]! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 10/16/2006 11:36'!
cachedAbsoluteActivity: anInteger
	^self cache at: self class absoluteActivityKey put: anInteger! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 10/16/2006 11:28'!
cachedDownloads
	^self cache
		at: self class downloadsKey
		ifAbsentPut: [ self numberOfTotalDownloads ]! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 10/16/2006 11:27'!
cachedDownloads: anInteger
	^self cache at: self class downloadsKey put: anInteger! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 11/15/2006 11:49'!
cachedNumberOfNormalVersions
	^self cache
		at: self class numberOfNormalVersionsKey
		ifAbsentPut: [ self numberOfNormalVersions ]! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 11/15/2006 11:50'!
cachedNumberOfNormalVersions: anInteger
	^self cache at: self class numberOfNormalVersionsKey put: anInteger! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 11/15/2006 11:50'!
cachedNumberOfReleases
	^self cache
		at: self class numberOfReleasesKey
		ifAbsentPut: [ self numberOfReleases ]! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 11/15/2006 11:50'!
cachedNumberOfReleases: anInteger
	^self cache at: self class numberOfReleasesKey put: anInteger! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 10/16/2006 13:08'!
cachedRelativeActivity
	^self cache
		at: self class relativeActivityKey
		ifAbsent: [ 0.0 ]! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 10/16/2006 11:36'!
cachedRelativeActivity: anInteger
	^self cache at: self class relativeActivityKey put: anInteger! !

!SSProject methodsFor: '*SqueakSource-Statistics-statistics' stamp: 'pmm 11/15/2006 12:07'!
numberOfCommitsBy: aMember
	^self countVersions: [ :each |
		each author = aMember ]! !

!SSProject methodsFor: '*SqueakSource-Statistics-statistics' stamp: 'pmm 11/15/2006 12:08'!
numberOfNormalVersions
	^self countVersions: [ :each |
		each isRelease not ]! !

!SSProject methodsFor: '*SqueakSource-Statistics-statistics' stamp: 'pmm 11/15/2006 12:08'!
numberOfReleases
	^self countVersions: [ :each |
		each isRelease ]! !

!SSProject methodsFor: '*SqueakSource-Statistics-statistics' stamp: 'pmm 10/16/2006 11:12'!
numberOfTotalDownloads
	| sum |
	sum := 0.
	self versionsDo: [ :each |
		sum := sum + each totalDownloads ].
	^sum! !

!SSProject methodsFor: '*SqueakSource-Statistics-actions' stamp: 'pmm 10/23/2006 16:26'!
reinititalizeInfos
	self versionsDo: [ :each |
		each reinititalizeInfoFor: self ]! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 10/16/2006 13:07'!
updateCachedAbsoluteActivity
	^self cachedAbsoluteActivity: self activity! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 10/16/2006 11:29'!
updateCachedDownloads
	^self cachedDownloads: self numberOfTotalDownloads! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 11/15/2006 11:51'!
updateCachedNumberOfNormalVersions
	^self cachedNumberOfNormalVersions: self numberOfNormalVersions! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'pmm 11/15/2006 11:51'!
updateCachedNumberOfReleases
	^self cachedNumberOfReleases: self numberOfReleases! !

!SSProject methodsFor: '*SqueakSource-Statistics' stamp: 'ul 1/8/2010 01:56'!
updateCachedRelativeActivity: maximumAbsoluteActivity
	^self cachedRelativeActivity: 
		(maximumAbsoluteActivity = 0
			ifTrue: [ 0 ]
			ifFalse: [ (self cachedAbsoluteActivity) / maximumAbsoluteActivity ])! !

!SSMember class methodsFor: '*SqueakSource-Statistics' stamp: 'topa 10/4/2010 10:49'!
cachedCommitCountKey

	^ #commitCount! !

!SSMember class methodsFor: '*SqueakSource-Statistics' stamp: 'topa 10/4/2010 10:49'!
cachedProjectCountKey

	^ #projectCount! !

!SSMember methodsFor: '*SqueakSource-Statistics' stamp: 'topa 10/4/2010 10:48'!
cache
	
	^ self propertyAt: #cache
		ifAbsentPut: [IdentityDictionary new]! !

!SSMember methodsFor: '*SqueakSource-Statistics' stamp: 'topa 10/4/2010 10:48'!
cachedCommitCount

	^ self cache
		at: self class cachedCommitCountKey
		ifAbsentPut: [ self commitCount ]! !

!SSMember methodsFor: '*SqueakSource-Statistics' stamp: 'topa 10/4/2010 10:48'!
cachedCommitCount: anInteger

	^ self cache
		at: self class cachedCommitCountKey
		put: anInteger! !

!SSMember methodsFor: '*SqueakSource-Statistics' stamp: 'topa 10/4/2010 10:48'!
cachedProjectCount

	^ self cache
		at: self class cachedProjectCountKey
		ifAbsentPut: [ self projectCount ]! !

!SSMember methodsFor: '*SqueakSource-Statistics' stamp: 'topa 10/4/2010 10:48'!
cachedProjectCount: anInteger

	^ self cache
		at: self class cachedProjectCountKey
		put: anInteger! !

!SSMember methodsFor: '*SqueakSource-Statistics-convenience' stamp: 'pmm 10/16/2006 12:01'!
commitCount
	| sum |
	sum := 0.
	self projectsDo: [ :each |
		sum := sum + (each numberOfCommitsBy: self) ].
	^sum! !

!SSMember methodsFor: '*SqueakSource-Statistics-convenience' stamp: 'pmm 10/16/2006 12:03'!
projectCount
	| count |
	count := 0.
	self projectsDo: [ :each |
		count := count + 1 ].
	^count! !

!SSMember methodsFor: '*SqueakSource-Statistics' stamp: 'topa 11/2/2010 12:10'!
updateCachedCommitCount

	^ self cachedCommitCount: self commitCount! !

!SSMember methodsFor: '*SqueakSource-Statistics' stamp: 'topa 11/2/2010 12:11'!
updateCachedProjectCount

	^ self cachedProjectCount: self projectCount! !

SSComponent subclass: #SSListPrinter
	instanceVariableNames: 'renderBlock title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Statistics-View'!

!SSListPrinter methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:23'!
renderBlock
	^renderBlock! !

!SSListPrinter methodsFor: 'accessing' stamp: 'dkh 05/17/2011 16:48'!
renderBlock: aBlock
	renderBlock := aBlock! !

!SSListPrinter methodsFor: 'rendering' stamp: 'dkh 05/17/2011 16:48'!
renderContentOn: html
	html heading: self title.
	html orderedList: [
		self model do: [ :each |
			html listItem: [
				self renderBlock value: html value: each ] ] ].
	html form: [ 
		html div: [
			html submitButton
				callback: [ self answer ];
				text: 'Close' ] ]! !

!SSListPrinter methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:55'!
title
	^title! !

!SSListPrinter methodsFor: 'accessing' stamp: 'dkh 05/17/2011 16:48'!
title: aString
	title := aString! !

SSComponent subclass: #SSProjectStats
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Statistics-View'!

!SSProjectStats methodsFor: 'rendering' stamp: 'dkh 05/17/2011 16:49'!
renderContentOn: html
	html heading level2; with: 'Statistics'.
	html table
		cellspacing: 0;
		cellpadding: 0;
		with: [
			html tableRow: [
				html tableData
					class: 'largeLabel';
					with: 'Registered:'.
				html tableData: self model timestamp ].
			
			html tableRow: [
				html tableData
					class: 'largeLabel';
					with: 'Total Releases:'.
				html tableData: self model cachedNumberOfReleases ].
			html tableRow: [
				html tableData
					class: 'largeLabel';
					with: 'Total Versions:'.
				html tableData: self model cachedNumberOfNormalVersions ].
			html tableRow: [
				html tableData
					class: 'largeLabel';
					with: 'Total Downloads:'.
				html tableData: self model cachedDownloads ] ].
		self renderMaxCommitsOn: html! !

!SSProjectStats methodsFor: 'rendering' stamp: 'dkh 05/17/2011 16:49'!
renderMaxCommitsOn: html
	html heading level2; with: 'Most commits by'.
	html table: [
		self model mostCommitsByMembers do: [:assoc | 
				html tableRow: [
					html tableData: assoc key.
					html tableData: assoc value ] ] ]! !

!SSProjectStats methodsFor: 'actions' stamp: 'dkh 01/04/2010 16:19'!
resetReport! !

!SSMembers methodsFor: '*SqueakSource-Statistics-columns' stamp: 'topa 5/10/2011 09:03'!
commitsColumn: aColumn

	<columnNamed: 'Commits' priority: 40 >
	
	aColumn
		accessor: #cachedCommitCount;
		sorter: [ :a : b | a cachedCommitCount > b cachedCommitCount ].! !

!SSMembers methodsFor: '*SqueakSource-Statistics-columns' stamp: 'topa 5/10/2011 08:40'!
projectsColumn: aColumn

	<columnNamed: 'Projects' priority: 30 >
	
	aColumn
		accessor: #cachedProjectCount;
		sorter: [ :a : b | a cachedProjectCount > b cachedProjectCount ].! !

!SSProjects methodsFor: '*SqueakSource-Statistics-columns' stamp: 'topa 5/10/2011 09:08'!
activityColumn: aColumn

	<columnNamed: 'Activity' priority: 50>
	
	aColumn 
		accessor: #yourself;
		renderer: [ :each :html |
			html table
				class: 'activityTable';
				cellspacing: 0;
				cellpadding: 0;
				with: [
					html tableRow: [
						html tableData
							style: 'background-color: ', (Color activity: each cachedRelativeActivity) asHTMLColor;
							with: [ html space; space; space ] ] ] ];
		sorter: [ :a : b | a cachedRelativeActivity > b cachedRelativeActivity ]! !

!SSProjects methodsFor: '*SqueakSource-Statistics-columns' stamp: 'topa 5/10/2011 09:17'!
downloadsColumn: aColumn

	<columnNamed: 'Downloads' priority: 60>
	
	aColumn 
		accessor: #cachedDownloads;
		sorter: [ :a : b | a cachedDownloads > b cachedDownloads ]! !
